"
 COPYRIGHT (c) 1997 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

SimpleView subclass:#NoteBookView
	instanceVariableNames:'tabRaw canvas canvasHolder'
	classVariableNames:''
	poolDictionaries:''
	category:'Views-Layout'
!

!NoteBookView class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1997 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

documentation
"
    this is not yet finished - for now it implements a Notebook

    [see also:]
        TabView
"
!

examples
"
    tabs at top ( default )
                                                                                [exBegin]                                      
    |top tab view inset|

    top  := StandardSystemView new label:'test'; extent:250@100.
    view := NoteBookView origin:0.0 @ 0.0 corner:1.0 @ 1.0 in:top.
    view list:#( 'Foo' 'Bar' 'Baz' ).
    view action:[:aName| Transcript showCR:aName].

    top open.
                                                                                [exEnd]


    tabs at bottom
                                                                                [exBegin]                                      
    |top tab view inset|

    top  := StandardSystemView new label:'test'; extent:250@100.
    view := NoteBookView origin:0.0 @ 0.0 corner:1.0 @ 1.0 in:top.
    view direction:#bottom.
    view list:#( 'Foo' 'Bar' 'Baz' ).
    view action:[:aName| Transcript showCR:aName].

    top open.
                                                                                [exEnd]

    tabs at left
                                                                                [exBegin]                                      
    |top tab view inset|

    top  := StandardSystemView new label:'test'; extent:100@200.
    view := NoteBookView origin:0.0 @ 0.0 corner:1.0 @ 1.0 in:top.
    view direction:#left.
    view list:#( 'Foo' 'Bar' 'Baz' ).
    view action:[:aName| Transcript showCR:aName].

    top open.
                                                                                [exEnd]

    tabs at right
                                                                                [exBegin]                                      
    |top tab view inset|

    top  := StandardSystemView new label:'test'; extent:100@200.
    view := NoteBookView origin:0.0 @ 0.0 corner:1.0 @ 1.0 in:top.
    view direction:#right.
    view list:#( 'Foo' 'Bar' 'Baz' ).
    view action:[:aName| Transcript showCR:aName].

    top open.
                                                                                [exEnd]


"
! !

!NoteBookView methodsFor:'accessing'!

canvas
    "returns canvas; the container view
    "
    ^ canvas
!

canvas:aCanvas
    "change canvas; the containter view
    "
    |origin corner|

    aCanvas == canvas ifFalse:[
        origin := canvas origin.
        corner := canvas corner.
        canvas destroy.

        (canvas := aCanvas) isNil ifTrue:[
            canvas := View in:self
        ] ifFalse:[
            self addSubView:canvas.
        ].
        canvas viewBackground:viewBackground.

        canvas allSubViewsDo:[:s|
            s viewBackground:viewBackground
        ].
        canvas origin:origin corner:corner.
    ]
!

labels
    ^ tabRaw list
!

labels:aListOfLabels
    tabRaw list:aListOfLabels
! !

!NoteBookView methodsFor:'accessing holders'!

canvasHolder
    ^ canvasHolder
!

canvasHolder:aValueHolder
    canvasHolder notNil ifTrue:[
        canvasHolder removeDependent:self. 
    ].
    canvasHolder := aValueHolder .
    self canvas:(canvasHolder value).
!

labelsHolder
    ^ tabRaw listHolder
!

labelsHolder:aHolder
    tabRaw listHolder:aHolder
! !

!NoteBookView methodsFor:'accessing look'!

backgroundColor:aColor
    "change viewBackground
    "
    self viewBackground:aColor
!

font:aFont
    "set a font
    "
    super font:aFont.
    tabRaw font:aFont.

!

viewBackground:aColor
    "viewBackground changed
    "
    viewBackground ~~ aColor ifTrue:[
        super  viewBackground:aColor.
        tabRaw viewBackground:viewBackground.
        canvas allSubViewsDo:[:s| s viewBackground:viewBackground].
    ]
! !

!NoteBookView methodsFor:'actions'!

clearCanvas
    "destroy all subviews in canvas
    "
    canvas destroySubViews


! !

!NoteBookView methodsFor:'change & update'!

recomputeSizes
    "recompute sizes dependent on list
    "
    |y x tabExt maxExt|


    maxExt := self extent - (margin * 2).
    tabExt := tabRaw preferredExtent.

    x := tabExt x.
    y := tabExt y.

    canvas viewBackground:(tabRaw styleAt:#selectedColor).
    tabRaw isHorizontalDirection ifTrue:[
        x > (maxExt x) ifTrue:[y := tabRaw preferredSizeXorY].

        tabRaw direction == #top ifTrue:[
            tabRaw origin:0.0@0.0 corner:1.0@(y+margin).
            canvas origin:0.0@(y+margin) corner:1.0@1.0.
        ] ifFalse:[
            y := maxExt y - y.
            canvas origin:0.0@0.0 corner:1.0@(y+margin).
            tabRaw origin:0.0@(y+margin) corner:1.0@1.0.
        ]
    ] ifFalse:[
        y > (maxExt y) ifTrue:[x := tabRaw preferredSizeXorY].

        tabRaw direction == #left ifTrue:[
            tabRaw origin:0.0@0.0 corner:(x+margin)@1.0.
            canvas origin:(x+margin)@0.0 corner:1.0@1.0.
        ] ifFalse:[
            x := maxExt x - x.
            canvas origin:0.0@0.0 corner:(x+margin)@1.0.
            tabRaw origin:(x+margin)@0.0 corner:1.0@1.0.
        ]
    ].



!

update:something with:aParameter from:changedObject
    "tabs changed
    "
    changedObject == tabRaw ifTrue:[
        something == #preferredExtent ifFalse:[
            something == #direction ifFalse:[
                ^ self
            ].
            tabRaw isHorizontalDirection ifTrue:[
                tabRaw origin:0.0@0.0 corner:1.0@0.0
            ] ifFalse:[
                tabRaw origin:0.0@0.0 corner:0.0@1.0
            ]
        ].
        self recomputeSizes
    ]
! !

!NoteBookView methodsFor:'event handling'!

doesNotUnderstand:aMessage
    (tabRaw respondsTo:(aMessage selector)) ifTrue:[
        ^ aMessage sendTo:tabRaw
    ].
    ^ super doesNotUnderstand:aMessage


! !

!NoteBookView methodsFor:'initialization'!

destroy
    "remove dependancies
    "
    canvasHolder notNil ifTrue:[
        canvasHolder removeDependent:self. 
    ].
    tabRaw removeDependent:self.
    self delegate:self.
    super destroy
!

initialize
    "initialize tabs and canvas
    "
    super initialize.

    tabRaw := TabView origin:0.0@0.0 corner:1.0@0.0 in:self.

 "/ class for canvas could be set by a subclass
    canvas isNil ifTrue:[
        canvas := View
    ].
    canvas := canvas origin:0.0@0.0 corner:1.0@1.0 in:self.

    tabRaw addDependent:self.
    self delegate:(KeyboardForwarder toView:tabRaw
                condition:nil
                filter:[:key | key size > 6 and:[key startsWith:#Cursor]]).

! !

!NoteBookView methodsFor:'selection'!

setSelection:something
    tabRaw setSelection:something
! !

!NoteBookView class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/libwidg2/NoteBookView.st,v 1.10 1998-01-28 15:12:43 ca Exp $'
! !
